"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var grpc_1 = require("./grpc");
var ExportMap_1 = require("./ExportMap");
var util_1 = require("./util");
var plugin_pb_1 = require("google-protobuf/google/protobuf/compiler/plugin_pb");
util_1.withAllStdIn(function (inputBuff) {
    try {
        var typedInputBuff = new Uint8Array(inputBuff.length);
        typedInputBuff.set(inputBuff);
        var codeGenRequest = plugin_pb_1.CodeGeneratorRequest.deserializeBinary(typedInputBuff);
        var codeGenResponse_1 = new plugin_pb_1.CodeGeneratorResponse();
        var exportMap_1 = new ExportMap_1.ExportMap();
        var fileNameToDescriptor_1 = {};
        codeGenRequest.getProtoFileList().forEach(function (protoFileDescriptor) {
            fileNameToDescriptor_1[protoFileDescriptor.getName()] = protoFileDescriptor;
            exportMap_1.addFileDescriptor(protoFileDescriptor);
        });
        codeGenRequest.getFileToGenerateList().forEach(function (fileName) {
            var outputFileName = util_1.replaceProtoGrpcSuffix(fileName);
            var thisFile = new plugin_pb_1.CodeGeneratorResponse.File();
            thisFile.setName(outputFileName + ".d.ts");
            thisFile.setContent(grpc_1.printFileDescriptorTSGRPC(fileNameToDescriptor_1[fileName], exportMap_1));
            codeGenResponse_1.addFile(thisFile);
        });
        process.stdout.write(new Buffer(codeGenResponse_1.serializeBinary()));
    }
    catch (err) {
        console.error("protoc-gen-grpc-ts error: " + err.stack + "\n");
        process.exit(1);
    }
});
//# sourceMappingURL=index.js.map